unit kniffel_u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TFolge = (FUE,VI,DR,ZW,ZP,FH,KST,GST);

  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button2: TButton;
    WuerfelnBtn: TButton;
    Button1: TButton;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure init;
    procedure auswerten(s:string);
    procedure WuerfelnBtnClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  Form1: TForm1;
  a : array[FUE..GST] of longint;
  ta : array['1'..'6'] of integer;

implementation

{$R *.DFM}

procedure TForm1.init;
var t : TFolge;
    ch : char;
begin
Randomize;
for t := fue to gst do a[t] := 0;
for ch := '1' to '6' do ta[ch] := 0;
Edit1.Text := ''; Edit2.Text := '';Edit3.Text := ''; Edit5.Text := '';
Edit6.Text := '';Edit7.Text := '';Edit8.Text := '';Edit9.Text := '';
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
init;
end;

procedure TForm1.Auswerten( s : string);
var  ch : char;
    m,n : integer;
    t : TFolge;
begin
for ch := '1' to '6' do ta[ch] := 0;
for n := 1 to 5 do  inc(ta[s[n]]);
m := 0;
for ch := '1' to '6' do if ta[ch] >= m then m := ta[ch];
  case m of
   1 : begin
       if ta['6'] = 0 then begin
          inc(a[kst]);
          Edit8.Text := IntToStr(a[kst]);
       end;
       if ta['1'] = 0 then begin
          inc(a[gst]);
          Edit9.Text := IntToStr(a[kst]);
       end;
       end;
   2 : begin
        t := zw; ch := '1'; while ta[ch] <> 2 do inc(ch); ta[ch] := 0;
        m := 0; for ch := '1' to '6' do if ta[ch] >= m then m := ta[ch];
        if m = 2 then t := zp;
        case t of
          zw : begin inc(a[zw]); Edit5.Text := IntToStr(a[zw]); end;
          zp : begin inc(a[zp]); Edit6.Text := IntToStr(a[zp]); end;
        end;
       end;
   3 : begin
        t := dr; ch := '1'; while ta[ch] <> 3 do inc(ch); ta[ch] := 0;
        m := 0; for ch := '1' to '6' do if ta[ch] >= m then m := ta[ch];
        if m = 2 then t := fh;
        case t of
          dr : begin inc(a[dr]); Edit3.Text := IntToStr(a[dr]); end;
          fh : begin inc(a[fh]); Edit7.Text := IntToStr(a[fh]); end;
        end;
       end;
   4 : begin inc(a[vi]); Edit2.Text := IntToStr(a[vi]); end;
   5 : begin inc(a[fue]); Edit1.Text := IntToStr(a[fue]); end;
end;
end;


function SechserZahl(n,s : integer):string;
var hs,ss : string;
    k,r : integer;
begin
hs := '';
for k := 1 to s do begin
  r := n mod 6; str(r+1,ss); hs := ss+hs;
  n := (n-r) div 6;
end;
result := hs;
end;


procedure TForm1.WuerfelnBtnClick(Sender: TObject);
var s : string;
begin
init;
s := SechserZahl(Random(15625),5);
Edit4.Text := s ;
auswerten(s);
end;

procedure TForm1.Button1Click(Sender: TObject);
var n : integer;
    s : string;
begin
init;
for n := 0 to 7775 do begin
  sleep(0);  Application.ProcessMessages;
  s := SechserZahl(n,5);
  Edit4.Text:= s;
  auswerten(s);
end;
end;


procedure TForm1.Button2Click(Sender: TObject);
begin
close;
end;


end.

